/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package student04_달력출력;

/**
 *
 * @author ned3y2k
 */
public class dateOperator {

    private int[] dayNo = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
    private int[][] week = new int[6][7];

    /**
     * 해당 월의 일자수를 구함
     * 
     * @param year int 대도연도
     * @param month int 대상월
     * @return int 일자
     */
    public int getMonthdayNo(int year, int month) {
        int resut;
        if (month == 2) {
            this.leapyear(year);
        }
        resut = this.dayNo[month - 1];

        return resut;
    }

    /**
     * 해당연도 일자수를 구함
     *
     * @param year int 대상 연도
     * @return int 일자수
     */
    private int getYeardayno(int year) {
        int i = 0;
        int sum = 0;

        this.leapyear(year);
        for (i = 0; i < this.dayNo.length; i++) {
            sum = sum + this.dayNo[i];
        }
        return sum;
    }

    /**
     * 경과일수 구함
     *
     * @param firstDate int [year, month, day]
     * @param secondDate int [year, month, day]
     * @return int 경과일
     */
    public int expireDay(int firstDate[], int secondDate[]) {
        int i;
        int expireDay = 0; // 경과일

        int tempYear = firstDate[0];
        int tempMonth = firstDate[1];

        for (i = firstDate[0]; i < secondDate[0]; i++) { // 년도에 따른 차이 구하기
            expireDay = expireDay + getYeardayno(tempYear);
            tempYear = tempYear + 1;
        }
        for (i = firstDate[1]; i < secondDate[1]; i++) { // 월에 따른 차이 구하기
            expireDay = expireDay + getMonthdayNo(tempYear, tempMonth);
            tempMonth = tempMonth + 1;
        }
        expireDay = expireDay - (firstDate[2]);
        expireDay = expireDay + (secondDate[2]);
        System.out.println();

        return expireDay;
    }

    /**
     * 해당일이 무슨 요일인지 결정함
     *
     * Order by
     * Sun:0 Mon:1 Tue:2 Wed:3 Thu:4 Fri:5 Sat:6
     *
     * @param year int 해당년도
     * @param month int 해당월
     * @return int
     */
    public int getWeekday(int Year, int Month, int Day) {
        int result, Weekday, A, B, C, D, E;

        A = Month + 10;
        B = ((Month - 14) / 12) + Year;
        C = A - (12 * (A / 13));
        D = ((13 * C) - 1) / 5;
        E = (5 * (B % 100)) / 4;
        
        Weekday = (D + Day + 77 + E + (B / 400) - (2 * B / 100)) % 7;


        result = Weekday - 1; // 토요일이 0으로 되는데 일요일을 0으로 되게 바꿈
        if (result == -1) { // 토요일이 -1로 되는데 6으로 나오게 설정
            Weekday = 6;
        }

        return result;
    }

    /**
     * 해당년이 윤년인지 구함
     *
     * @param 해당월
     */
    private void leapyear(int year) {
        this.dayNo[1] = 28;
        if (year % 4 == 0 && year % 100 != 0 || year % 400 == 0) {
            this.dayNo[1] = 29;
        }
    }

    /**
     * 달력 배열을 만들어서 돌려줌
     *
     * @param year int 대상연도
     * @param month int 대상월
     * @return int[]
     */
    public int[] getCalandar(int year, int month) {
        int result[] = new int[37];
        int i = 0;
        int day = 1;
        int maxDay = this.getMonthdayNo(year, month);
        int startPos = getWeekday(year, month, 1);
        int endPos = startPos + maxDay;

        for (i = (startPos +1); i <= endPos; i++) {
            result[i] = day;
            day = day + 1;
        }

    return result;
    }
}
